<?php

/**
 * Frontend controller to add LayoutBuddy articles to cart
 *
 * @category   Shopware
 * @package    Plugins
 * @subpackage Frontend
 * @author     LayoutBuddy Software GmbH
 * @copyright  Copyright © 2013 LayoutBuddy Software GmbH
 */

class Shopware_Controllers_Frontend_LyByCheckout extends Shopware_Controllers_Frontend_Checkout
{

    /**
    * Init method, called automatically
    */
    public function init()
    {
        parent::init();
    }

    /**
    * Pre dispatch method
    */
    public function preDispatch()
    {
        parent::preDispatch();
        Shopware()->Plugins()->Controller()->ViewRenderer()->setNoRender();
    }

    /**
    * override addArticleAction
    * 
    * @return type 
    */
    public function addArticleAction()
    {
        $ordernumber = $this->Request()->getParam('sAdd');
        $quantity = $this->Request()->getParam('sQuantity');
        $articleID = Shopware()->Modules()->Articles()->sGetArticleIdByOrderNumber($ordernumber);

        if (!empty($articleID)) {

            $config = Shopware()->Plugins()->Frontend()->LyByLayoutBuddy()->Config();

            $insertID = Shopware_Plugins_Frontend_LyByLayoutBuddy_Classes_sBasket::sAddArticle(
                $this->basket,
                $ordernumber,
                $quantity,
                true
            );

            $targetItem = null;
            if (!empty($insertID)) {
                $basket = $this->getBasket();
                foreach ($basket['content'] as $item) {
                    if ($item['id'] == $insertID) {
                        $targetItem = $item;
                        break;
                    }
                }
            }

            if ($targetItem) {
                $article = Shopware()->Modules()->Articles()->sGetArticleById($targetItem['articleID']);
                if (isset($article['lb_use_for_layout']) && (int)$article['lb_use_for_layout']) {
                    if ($layoutId = $this->Request()->getParam('lbLayoutId')) {

                        if (empty($config->lbPrivateKey) || !$config->lbPrivateKey) return;
                        if (empty($config->lbPublicKey) || !$config->lbPublicKey) return;

                        $api = new Shopware_Plugins_Frontend_LyByLayoutBuddy_Classes_Api($config->lbPublicKey, $config->lbPrivateKey);
                        $apiParams = array(       
                            'id' => $layoutId,
                        );

                        try {
                            $detailsObject = json_decode($api->request('details', $apiParams, true), true);
                            $parameters = $detailsObject['options'];
                            array_unshift($parameters, array(
                                'qty' => 1,
                                'label' => $detailsObject['width'] . 'x' . $detailsObject['height'] . $detailsObject['unit'],
                                'price' => 0,
                            ));
                            $options = json_encode($parameters);

                            if (!isset($detailsObject['price'])) return;
                            $result = Shopware()->Db()->update(
                                's_order_basket_attributes',
                                array(
                                    'lb_layout_id' => $layoutId,
                                    'lb_custom_price' => (float)$detailsObject['price'],
                                    'lb_layout_options' => $options,
                                ),
                                array('basketID = ?' => $item['id'])
                            );
                        } catch (Exception $e) {
                            
                        }
                    }
                }
            }
        }

        $this->Response()->setBody($this->Request()->getParam('callback') . '("")');
        return;
    }

}